# Generated by Django 2.0 on 2018-02-27 05:00

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Query',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=128)),
                ('query', models.TextField()),
                ('creator', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='QueryParameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=32)),
                ('variable', models.CharField(max_length=32)),
                ('default', models.CharField(max_length=250)),
                ('is_array', models.BooleanField(default=False)),
                ('param_type', models.PositiveSmallIntegerField(choices=[(0, 'Integer'), (1, 'Float'), (2, 'String'), (3, 'Date'), (1000, 'Other')])),
                ('query', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='orml.Query')),
            ],
        ),
        migrations.CreateModel(
            name='Snapshot',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=32)),
                ('namespace', models.CharField(max_length=32)),
                ('save_meta', models.BooleanField(default=False)),
                ('meta_object_key', models.CharField(blank=True, max_length=32, null=True)),
                ('meta_content_type', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
                ('query', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='orml.Query')),
            ],
        ),
        migrations.CreateModel(
            name='SnapshotMeta',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.PositiveIntegerField()),
                ('json_data', models.TextField()),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
        ),
        migrations.AlterUniqueTogether(
            name='snapshotmeta',
            unique_together={('content_type', 'object_id')},
        ),
    ]
